/*
 	File:		HIDialogTypes.h
 
 	Version:	Technology:	Copland
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __HIDIALOGTYPES__
#define __HIDIALOGTYPES__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=power
/* the following contents can only be used by compilers that support PowerPC struct alignment */

#if FOR_SYSTEM8_COOPERATIVE
#ifdef __cplusplus
	class HIDialog;
#else
	#include <som.h>
	#ifndef HIDialog
		#define HIDialog SOMObject
	#endif
#endif

enum {
	kHIStateChangeDialogDismissed = 'ddsm'
};

/* Different types of standard alerts*/
typedef UInt32 HIAlertType;

enum {
	kHINormalAlert				= 0,
	kHINoteAlert				= 1,
	kHICautionAlert				= 2,
	kHIStopAlert				= 3
};

#endif

#pragma options align=reset
#endif /* PRAGMA_ALIGN_SUPPORTED */

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __HIDIALOGTYPES__ */

