/*
 	File:		HIListTypes.h
 
 	Version:	Technology:	Copland
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __HILISTTYPES__
#define __HILISTTYPES__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=power
/* the following contents can only be used by compilers that support PowerPC struct alignment */

#if FOR_SYSTEM8_COOPERATIVE
#ifdef __cplusplus
	class HIMenu;
#else
	#include <som.h>
	#ifndef HIMenu
		#define HIMenu SOMObject
	#endif
#endif
typedef UInt32 HIItemAttributes;
typedef UInt32 HIItemState;
typedef UInt32 HIItemIndex;

enum {
	kHIFirstItem				= 0x00000000,
	kHILastItem					= 0xFFFFFFFF,
	kHIEveryItem				= 0xFFFFFFFE,
	kHIInvalidItem				= 0xFFFFFFFD
};


enum {
	kHIItemIsSelected			= 0x80000000,
	kHIItemIsDisabled			= 0x40000000
};


enum {
	kHIItemIsSeparator			= 0x00000001
};


enum {
	kHIStateChangeItemSelected	= 'slct'
};


enum {
	kHIItemEnableHilite			= 0x01,
	kHIItemEnableText			= 0x02,
	kHIItemEnableMark			= 0x04,
	kHIItemEnableIcon			= 0x08,
	kHIItemEnableCommand		= 0x10,
	kHIItemEnableNone			= 0x00,
	kHIItemEnableAll			= 0xFF
};


enum {
																/* Use the following with HIMenu::SetItemAccelerator*/
	kHIAcceleratorCommand		= 0x01,
	kHIAcceleratorShift			= 0x02,
	kHIAcceleratorCapsLock		= 0x04,
	kHIAcceleratorOption		= 0x08,
	kHIAcceleratorControl		= 0x10,
	kHIAcceleratorNone			= 0x00
};


enum {
	kHIMenuGridHasBorder		= 0x01
};

typedef OptionBits HIMenuGridOptions;
struct HIMenuGrid {
	UInt16 							rows;
	UInt16 							rowHeight;
	UInt16 							columns;
	UInt16 							columnWidth;
	HIMenuGridOptions 				options;
};
typedef struct HIMenuGrid HIMenuGrid;

typedef HIMenuGrid *HIMenuGridPtr;
#endif

#pragma options align=reset
#endif /* PRAGMA_ALIGN_SUPPORTED */

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __HILISTTYPES__ */

