/*
 	File:		HIObjectTypes.h
 
 	Version:	Technology:	Copland
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __HIOBJECTTYPES__
#define __HIOBJECTTYPES__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=power
/* the following contents can only be used by compilers that support PowerPC struct alignment */

#if FOR_SYSTEM8_COOPERATIVE
#ifdef __cplusplus
	#include <som.xh>
#else
	#include <som.h>
#endif
#ifdef __cplusplus
	class HIObject;
#else
	#include <som.h>
	#ifndef HIObject
		#define HIObject SOMObject
	#endif
#endif
typedef OSType HIStateChangeCodeCreator;

enum {
	kHIObjectAppleCreator		= 'aapl'
};

typedef OSType HIStateChangeCode;

enum {
	kHIStateChangeObjectBoundsChanging = 'bnd1',
	kHIStateChangeObjectBoundsChanged = 'bnd2',
	kHIStateChangeObjectVisibilityChanging = 'vis1',
	kHIStateChangeObjectVisibilityChanged = 'vis2'
};

typedef void (*HIStateChangeCallbackProcPtr)(Environment *ev, HIStateChangeCodeCreator selectorCreator, HIStateChangeCode whatHappened, HIObject *theObject);
typedef struct OpaqueHIStateChangeCallbackRef* HIStateChangeCallbackRef;
/* current version of the initializer data structure*/

enum {
	kCurrentHIObjectInitializerVersion = 1
};

typedef OptionBits HIAdoptionFlags;

enum {
	kHINoAdoptionFlags			= 0x0000,
	kHIAdoptDispose				= 0x0001,
	kHIDefaultImageRefAdoptionFlags = kHIAdoptDispose
};

typedef OptionBits HIDrawingMode;

enum {
	kHIDrawNextUpdateEvent		= 0x00000000,					/* default*/
	kHIDrawImmediately			= 0x00000001,
	kHIDeferDrawing				= 0x00000002
};

typedef OSType HICoordinateSystem;

enum {
	kHICoordScreenRelative		= 'scrn',						/* global coordinates*/
	kHICoordPortRelative		= 'port',
	kHICoordObjectRelative		= 'obj '
};

typedef OptionBits HIUserInputFocusFlags;

enum {
	kHICanTakeUserInputFocus	= 0x00000001,
	kHITakesUserInputFocusWhenClicked = 0x00000002
};

typedef OptionBits HIClipboardSupportFlags;

enum {
	kHISupportsCut				= 0x00000001,
	kHISupportsCopy				= 0x00000002,
	kHISupportsPaste			= 0x00000003,
	kHISupportsClear			= 0x00000004
};

typedef OptionBits HIAERecordDataFormat;

enum {
	kHIUseResourceReferences	= 0x00000000,
	kHIFlattenAllData			= 0x00000001,
	kHISimpleValuesOnly			= 0x00000002
};


enum {
	errHIObjectHasInvalidState	= -1,							/* returned by verify if panel is internally messed up*/
	errHIObjectAllocation		= -1,							/* could not allocate SOM object*/
	errHINoObjectWithThisRefLabel = -1							/* no existing HIObject with this id*/
};


enum {
	keyHISubclassInitializer	= 'scls'
};

#endif

#pragma options align=reset
#endif /* PRAGMA_ALIGN_SUPPORTED */

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __HIOBJECTTYPES__ */

