/*
 	File:		OSAComp.h
 
 	Contains:	AppleScript Component Implementor's Interfaces.
 
 	Version:	Technology:	AppleScript 1.1
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __OSACOMP__
#define __OSACOMP__

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif
#ifndef __OSA__
#include <OSA.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

#if FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE
/*
*************************************************************************
	Types and Constants
*************************************************************************
*/
/*
*************************************************************************
	Routines for Associating a Storage Type with a Script Data Handle 
*************************************************************************
*/
extern pascal OSErr OSAGetStorageType(Handle scriptData, DescType *dscType);

extern pascal OSErr OSAAddStorageType(Handle scriptData, DescType dscType);

extern pascal OSErr OSARemoveStorageType(Handle scriptData);

#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __OSACOMP__ */

