/*
 	File:		SNSRegistry.h
 
 	Contains:	System Notification Service Registry of services and kinds.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __SNSREGISTRY__
#define __SNSREGISTRY__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

#if FOR_SYSTEM8_PREEMPTIVE

enum {
	kSNSDeathNotificationService = 'deth',						/*  0x64657468  */
	kSNSFSNotificationService	= 'file'						/*  0x66696c65  */
};


enum {
	kSNSProcessKind				= 'proc',						/*  0x70726f63  */
	kSNSKernelProcessKind		= 'kprc',						/*  0x6b707263  */
	kSNSTaskKind				= 'task'						/*  0x7461736b  */
};

#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __SNSREGISTRY__ */

