/*
 	File:		TextEngines.h
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __TEXTENGINES__
#define __TEXTENGINES__

#ifndef __TYPES__
#include <Types.h>
#endif
#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif
#ifndef __TEXTENGINETYPES__
#include <TextEngineTypes.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

#if FOR_SYSTEM8_COOPERATIVE
extern OSStatus GetNewTextEngineBySignature(TextEngineID theEngineSignature, TSystemTextEngine **theEngine);

extern OSStatus GetNewTextEngineByClassName(Str32 className, SInt32 majorVersion, SInt32 minorVersion, TSystemTextEngine **theTextEngine);

extern OSStatus GetSystemTextEngineInstance(TSystemTextEngine **theTextEngine);

extern OSStatus FindTextEngine(TextEngineFeature theDesiredFeatures[], ItemCount nFeatures, TSystemTextEngine **theTextEngine);

extern OSStatus IsFeatureSupported(TextEngineID theEngineSignature, TextEngineFeature theDesiredFeature, Boolean *isSupported);

#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __TEXTENGINES__ */

