/*
 	File:		Tokenize.h
 
 	Contains:	Text Services Manager Tokenizer interfaces
 
 	Version:	Technology:	System 8.0
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/
#ifndef __TOKENIZE__
#define __TOKENIZE__

#ifndef __TYPES__
#include <Types.h>
#endif
#ifndef __TEXTOBJECTS__
#include <TextObjects.h>
#endif
#ifndef __TEXTSERVICES__
#include <TextServices.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

#if FOR_SYSTEM8_PREEMPTIVE

enum {
	kTKNNoControlFlags			= 0,
	kTKNSplitTextStreamFlag		= 1
};

/*
 *
 * Tokenize Functions 
 *
*/
extern OSStatus TKNSetTextRun(TSMContext context, TextObject run);

extern OSStatus TKNGetTextRun(TSMContext context, TextObject run);

extern OSStatus TKNGetNextToken(TSMContext context, TextObject token);

extern OSStatus TKNGetTokenPosition(TSMContext context, TextObjectIndex *theStart, TextObjectIndex *theEnd);

extern OSStatus TKNSetControlFlags(TSMContext context, long controlFlags);

extern OSStatus TKNGetControlFlags(TSMContext context, long *controlFlags);

#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __TOKENIZE__ */

